#%RAML 1.0
version: v1
baseUri: https://anypoint.mulesoft.com/mocking/api/v1/links/c6edfde1-c9f3-4772-9152-5e24d786b710/ # 
title: Audit Log Function API
description: API for saving/updating audit log 

types:
  saveLogRequest: !include /Datatype/saveLogRequest.raml
  updateLogRequest: !include /Datatype/updateLogRequest.raml
  saveLogSuccessfulResponse: !include Datatype/saveLogSuccessfulResponse.raml
  updateLogSuccessfulResponse: !include Datatype/updateLogSuccessfulResponse.raml
  logErrorResponse: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/api-response-datatype-api/1.0.0/api-response-datatype-api.raml

traits:
  headerTraits: !include exchange_modules/a9d53ff2-5476-4a1f-8d1a-b19eb82612cc/header-securable/1.0.0/header-securable.raml


/log:
  post:
    is:
      - headerTraits
    description: Save an audit log transaction
    headers:
      correlationid:
        type: string
        description: Tranasction ID that is passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    body:
      application/json:
        type: saveLogRequest
        example: !include Examples/saveLog/saveLogRequestExample.json
    responses:
      200:
        body:
          application/json:
            type: saveLogSuccessfulResponse
            example:
              !include Examples/saveLog/saveLogSuccessfulResponseExample.json
      400:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError400Example.json
      404:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError404Example.json 
      405:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError405Example.json
      406:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError406Example.json
      415:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError415Example.json
      501:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError501Example.json
      500:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/saveLog/saveLogResponseError500Example.json

/log/{ID}:              
  uriParameters:
    ID:
      description: ID of the audit log transaction to be updated
      example: "1"
  put:
    is:
      - headerTraits
    description: Update an audit log transaction
    headers:
      correlationid:
        type: string
        description: Tranasction ID that is passed on from the previous API
        example: "0-dbfedf90-284c-11e9-ac48-dca90494651"
    body:
     application/json:
      type: updateLogRequest 
      example: !include Examples/updateLog/updateLogRequestExample.json
    responses:
      200:
        body:
          application/json:
            type: updateLogSuccessfulResponse
            example:
              !include Examples/updateLog/updateLogSuccessfulResponseExample.json
      400:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError400Example.json
      404:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError404Example.json 
      405:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError405Example.json
      406:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError406Example.json
      415:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError415Example.json
      501:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError501Example.json
      500:
        body:
          application/json:
            type: logErrorResponse
            example: !include Examples/updateLog/updateLogResponseError500Example.json
              